PROGRAM cd_s (input,output);

  CONST
    maxaantal = 20;

  TYPE
    lied = RECORD
             duur : integer;
             kant : 1..2;
           END;
    tijd = ARRAY [1..maxaantal] OF lied;

  VAR
    tijden   : tijd;
    aantal   : integer;
    diep     : integer;
    tijd_a   : integer;
    tijd_b   : integer;
    mogelijk : boolean;
    bandtijd : integer;
    verschil : integer;

  PROCEDURE invoer(VAR tijden:tijd;VAR aantal:integer;VAR bandtijd:integer);

    VAR
      hulp : real;

    BEGIN          (* invoer *)
      writeln(chr(12));
      writeln('Voer nu de tijden in van de te onderzoeken nummer (0 om te stoppen).');
      writeln('Voorbeeld : 3.12');
      writeln;
      aantal:=0;
      hulp:=1;
      WHILE (hulp>0) AND (aantal<maxaantal) DO
      BEGIN
        write('Geef de tijd van nummer ',aantal+1:2,' : ');
        readln(hulp);
        IF hulp>0 THEN
        BEGIN
          aantal:=aantal+1;
          tijden[aantal].duur:=trunc(hulp)*60+round((hulp-trunc(hulp))*100);
        END;
        writeln;
      END;
      writeln;
      writeln('Geef nu de duur van het bandje (voer 0 in voor ideale verdeling)');
      write('Bandtijd : ');
      readln(bandtijd);
      bandtijd:=bandtijd*60;
      writeln;
      writeln('Ik ga nu rekenen.');
      writeln('Even geduld A.U.B.');
    END;           (* invoer *)

  PROCEDURE afdrukken(tijden:tijd;aantal:integer);

    VAR
      hulp1 : integer;
      hulp2 : integer;

    BEGIN          (* afdrukken *)
      writeln(chr(12));
      writeln('Kant A :');
      write('Nummers : ');
      hulp2:=0;
      FOR hulp1:=1 TO aantal DO
        IF tijden[hulp1].kant=1 THEN
        BEGIN
          hulp2:=hulp2+tijden[hulp1].duur;
          write(hulp1:2,' ');
        END;
      writeln(': ',(hulp2 DIV 60):1,'.',(hulp2 MOD 60):2);
      writeln;
      writeln('Kant B :');
      write('Nummers : ');
      hulp2:=0;
      FOR hulp1:=1 TO aantal DO
        IF tijden[hulp1].kant=2 THEN
        BEGIN
          hulp2:=hulp2+tijden[hulp1].duur;
          write(hulp1:2,' ');
        END;
      writeln(': ',(hulp2 DIV 60):1,'.',(hulp2 MOD 60):2);
      writeln;
      writeln;
      writeln;
      write('Druk <RETURN>');
      readln;
    END;           (* afdrukken *)

  PROCEDURE berekening(VAR tijden:tijd;aantal:integer;VAR tijd_a,tijd_b,
                       diep:integer;VAR mogelijk:boolean;verschil,bandtijd:integer);

    BEGIN          (* berekening *)
      IF NOT mogelijk THEN
        IF diep=aantal THEN
        BEGIN
          IF bandtijd<>0 THEN
          BEGIN
            IF ((bandtijd DIV 2)-tijd_a)=verschil THEN
            BEGIN
              mogelijk:=TRUE;
              afdrukken(tijden,aantal);
            END
          END
          ELSE
          BEGIN
            IF abs(tijd_a-tijd_b)<=verschil THEN
            BEGIN
              mogelijk:=TRUE;
              afdrukken(tijden,aantal);
            END
          END
        END
        ELSE
        BEGIN
          diep:=diep+1;
          tijden[diep].kant:=1;
          tijd_a:=tijd_a+tijden[diep].duur;
          berekening(tijden,aantal,tijd_a,tijd_b,diep,mogelijk,verschil,bandtijd);
          tijd_a:=tijd_a-tijden[diep].duur;
          tijden[diep].kant:=2;
          tijd_b:=tijd_b+tijden[diep].duur;
          berekening(tijden,aantal,tijd_a,tijd_b,diep,mogelijk,verschil,bandtijd);
          tijd_b:=tijd_b-tijden[diep].duur;
          diep:=diep-1;
        END;
    END;           (* berekening *)

  FUNCTION stoppen:boolean;

    VAR
      antwoord : char;

    BEGIN          (* stoppen *)
      write('Nog een CD (J/N) : ');
      readln(antwoord);
      stoppen:=NOT (antwoord IN ['j','J']);
    END;           (* stoppen *)

  BEGIN            (* Hoofdprogramma *)
    REPEAT
      invoer(tijden,aantal,bandtijd);
      diep:=0;
      tijd_a:=0;
      tijd_b:=0;
      verschil:=0;
      mogelijk:=FALSE;
      WHILE NOT mogelijk DO
      BEGIN
        write('*');
        berekening(tijden,aantal,tijd_a,tijd_b,diep,mogelijk,verschil,bandtijd);
        verschil:=verschil+1;
      END;
      writeln(chr(12));
      writeln('''t Is voorbij !!!');
      writeln;
    UNTIL stoppen;
    writeln(chr(12));
    writeln('Coding : Jeroen ''KUBIE'' Smael');
    writeln('           Galopiahof 6');
    writeln('             6215TK Maastricht');
    writeln('               Tel : 043-437778');
    writeln;
    writeln;
    writeln('Dit programma hoort bij FutureDisk #12');
    writeln;
    writeln;
    writeln('C YA @ !!');
  END.             (* Hoofdprogramma *)